import type { NodePath } from '@babel/traverse';
import type * as Babel from '@babel/core';
import type { types as t } from '@babel/core';
import { ImportUtil } from 'babel-import-util';
import { ExtendedPluginBuilder } from './js-utils';
import type { EmberTemplateCompiler } from './ember-template-compiler';
export declare type LegacyModuleName = 'ember-cli-htmlbars' | 'ember-cli-htmlbars-inline-precompile' | 'htmlbars-inline-precompile';
export interface Options {
    compiler: EmberTemplateCompiler;
    outputModuleOverrides?: Record<string, Record<string, [string, string]>>;
    enableLegacyModules?: LegacyModuleName[];
    targetFormat?: 'wire' | 'hbs';
    transforms?: ExtendedPluginBuilder[];
}
export interface State<EnvSpecificOptions> {
    opts: EnvSpecificOptions;
    normalizedOpts: Required<Options>;
    util: ImportUtil;
    templateFactory: {
        moduleName: string;
        exportName: string;
    };
    program: NodePath<t.Program>;
    lastInsertedPath: NodePath<t.Statement> | undefined;
    filename: string;
}
export default function makePlugin<EnvSpecificOptions>(loadOptions: (opts: EnvSpecificOptions) => Options): (babel: typeof Babel) => Babel.PluginObj<State<EnvSpecificOptions>>;
